<template>
	<div class="statistics-department-dp-return-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline>
				<el-form-item prop="crTime">
					<statistical-time v-model="state.queryParams.crTime" @change="handleQuery" ref="statisticalTimeRef" :disabled="state.loading" />
				</el-form-item>
				<el-form-item label="部门名称" prop="OrgName">
					<el-input v-model="state.queryParams.OrgName" placeholder="部门名称" clearable @keyup.enter="handleQuery" class="keyword-input" />
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
						<SvgIcon name="ele-Refresh" class="mr5" />重置
					</el-button>
				</el-form-item>
			</el-form>
			<vxe-toolbar
				ref="toolbarRef"
				:loading="state.loading"
				custom
				:refresh="{
					queryMethod: handleQuery,
				}"
				:tools="[{ toolRender: { name: 'exportAll' } }]"
			>
				<template #buttons>
					<el-button type="primary" @click="linkDetail(null)">明细表</el-button>
				</template>
			</vxe-toolbar>
			<div style="overflow: hidden; width: 100%; height: 100%; flex: 1">
				<vxe-table
					border
					:loading="state.loading"
					:data="state.tableData"
					:column-config="{ resizable: true }"
					:row-config="{ isCurrent: true, isHover: true, height: 30, useKey: true }"
					ref="tableRef"
					height="auto"
					auto-resize
					:scrollY="{ enabled: true, gt: 100 }"
					show-overflow
					id="statisticsDepartmentDpReturn"
					:custom-config="{ storage: true }"
					:params="{ exportMethod: departmentReturnExport, exportParams: requestParams }"
				>
					<vxe-column field="orgName" title="部门名称"></vxe-column>
					<vxe-column field="num" title="数量">
						<template #default="{ row }">
							<el-button type="primary" link @click="linkDetail(row, '1')">{{ row.num }}</el-button>
						</template>
					</vxe-column>
				</vxe-table>
			</div>
		</div>
	</div>
</template>
<script setup lang="tsx" name="statisticsDepartmentDpReturn">
import { defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { defaultDate } from '@/utils/constants';
import Other from '@/utils/other';
import { useRouter } from 'vue-router';
import { departmentReturn, departmentReturnExport } from '@/api/statistics/department';

const StatisticalTime = defineAsyncComponent(() => import('@/components/StatisticalTime/index.vue')); // 日期类型选择组件
const ruleFormRef = ref<RefType>(); // 表单ref
const state = reactive<any>({
	queryParams: {
		// 查询条件
		crTime: defaultDate, // 时间默认今天开始到今天结束
		OrgName:null,
	},
	tableData: [],
	loading: false, // 加载
	total: 0, // 总数
});
/** 搜索按钮操作 */
const handleQuery = () => {
	// state.queryParams.PageIndex = 1;
	queryList();
};
/** 获取列表 */
const requestParams = ref<EmptyObjectType>({});
const queryList = () => {
	state.loading = true;
	requestParams.value = Other.deepClone(state.queryParams);
	requestParams.value.StartTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[0];
	requestParams.value.EndTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[1];
	Reflect.deleteProperty(requestParams.value, 'crTime');
	departmentReturn(requestParams.value)
		.then((res: any) => {
			state.tableData = res.result ?? [];
			state.loading = false;
		})
		.catch(() => {
			state.loading = false;
		});
};
/** 重置按钮操作 */
const statisticalTimeRef = ref<RefType>();
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	statisticalTimeRef.value.reset();
	queryList();
};
// 查看详情
const router = useRouter();
const linkDetail = (row: any, type?: string) => {
	if (row) {
		// 点击数字
		if (row.orgName === '合计') {
			router.push({
				path: '/statistics/department/detailDpReturn',
				query: {
					tagsViewName: '部门退件明细',
					mode: 'detail',
					StartTime: state.queryParams.crTime[0],
					EndTime: state.queryParams.crTime[1],
					Type: type,
				},
			});
		} else {
			router.push({
				path: '/statistics/department/detailDpReturn',
				query: {
					tagsViewName: '部门退件明细',
					mode: 'detail',
					OrgId: row.orgId,
					StartTime: state.queryParams.crTime[0],
					EndTime: state.queryParams.crTime[1],
					Type: type,
				},
			});
		}
	} else {
		router.push({
			path: '/statistics/department/detailDpReturn',
			query: {
				tagsViewName: '部门退件明细',
				mode: 'list',
			},
		});
	}
};
const toolbarRef = ref<RefType>();
const tableRef = ref<RefType>();
onMounted(() => {
	queryList();
	if (tableRef.value && toolbarRef.value) {
		tableRef.value.connect(toolbarRef.value);
	}
});
</script>
